<template>
  <button type="button" class="btn" :class="{ [theme]: theme, [icon]: icon }">
    <slot />
  </button>
</template>
<script>
export const themes = {
  prime: "btn-prime",
  light: "btn-light",
  ico: "",
};

export const icons = {
  plus: "btn-plus",
  save: "btn-save",
  cancel: "btn-block",
  back: "btn-back",
  next: "btn-next",
  remove: "btn-remove",
  removeSmall: "btn-remove-sm",
  edit: "btn-edit",
  editSmall: "btn-edit-sm",
  none: "",
};

export default {
  name: "AppButton",
  components: {},
  props: {
    theme: {
      validator: (val) => Object.values(themes).includes(val),
      default: themes.light,
    },
    icon: {
      validator: (val) => Object.values(icons).includes(val),
      default: icons.none,
    },
  },
};
</script>

<style>
.btn {
  text-decoration: none;
  font-size: 14px;
  line-height: 12px;
  border-radius: 6px;
  height: 40px;
  display: inline-block;
  user-select: none;
  cursor: pointer;
  border: none;
  background-color: transparent;
  transition: all 0.2s ease;
}

.btn.btn-prime {
  background-color: #106edc;
  border: solid 1px #106edc;
  padding: 13px 16px;
  color: #ffffff;
}

.btn.btn-light {
  background-color: #ffffff;
  padding: 13px 16px;
  border: solid 1px #dfe3e7;
  color: #0c2747;
  overflow: auto;
  margin: 0 5px;
}

.btn.btn-plus {
  background-image: url(@/assets/icons/plus.svg);
  background-repeat: no-repeat;
  background-position: top 50% left 15px;
  padding-left: 44px;
}
.btn.btn-save {
  background-image: url(@/assets/icons/save.svg);
  background-repeat: no-repeat;
  background-position: top 50% left 15px;
  color: #0c2747;
  font-weight: 500;
  padding-left: 44px;
}
.btn.btn-next {
  background-image: url(@/assets/icons/forward.svg);
  background-repeat: no-repeat;
  background-position: top 50% left 15px;
  color: #0c2747;
  font-weight: 500;
  padding-left: 44px;
}
.btn.btn-back {
  background-image: url(@/assets/icons/back.svg);
  background-repeat: no-repeat;
  background-position: top 50% left 15px;
  color: #0c2747;
  font-weight: 500;
  padding-left: 44px;
}
.btn.btn-block {
  background-image: url(@/assets/icons/block.svg);
  background-repeat: no-repeat;
  background-position: top 50% left 15px;
  color: #0c2747;
  font-weight: 500;
  padding-left: 44px;
}
.btn.btn-remove {
  background-image: url(@/assets/icons/delete.svg);
  background-repeat: no-repeat;
  display: inline-block;
  line-height: 14px;
  width: 24px;
  height: 24px;
  vertical-align: bottom;
  margin: 0 12px;
}

.btn.btn-edit {
  background-image: url(@/assets/icons/edit.svg);
  background-repeat: no-repeat;
  display: inline-block;
  line-height: 14px;
  width: 24px;
  height: 24px;
  vertical-align: bottom;
  margin: 3px 12px 0 12px;
}
.btn.btn-remove-sm {
  background-image: url(@/assets/icons/delete-sm.svg);
  background-repeat: no-repeat;
  display: inline-block;
  line-height: 14px;
  width: 16px;
  height: 16px;
  vertical-align: bottom;
  margin: 0 12px;
}

.btn.btn-edit-sm {
  background-image: url(@/assets/icons/edit-sm.svg);
  background-repeat: no-repeat;
  display: inline-block;
  line-height: 14px;
  width: 16px;
  height: 16px;
  vertical-align: bottom;
  margin: 3px 12px 0 12px;
}
.btn-prime:hover {
  background-color: #0a347a;
  border: solid 1px #0a347a;
}

.btn-light:hover {
  background-color: #f5f5f5;
}
</style>
